<script setup lang="ts">
    import { GmaoConfigurationIntervention } from '@/interventionServiceOffer/entities/gmaoConfigurationIntervention/GmaoConfigurationIntervention'
    import { GmaoConfigurationInterventionApi } from '@/interventionServiceOffer/entities/gmaoConfigurationIntervention/GmaoConfigurationInterventionApi'
    import { InterventionServiceOffer } from '@/interventionServiceOffer/entities/interventionServiceOffer/InterventionServiceOffer'
    import { useMsal } from '@/plugins/msal/useMsal'
    import {
        WritableComputedRef,
        ref,
        watch,
        computed,
        ComputedRef,
        Ref,
    } from 'vue'
    import SActionButton from '@/shared/button/components/SActionButton.vue'
    import { VolatileRef } from '@/shared/helpers/lifeCycle'
    import {
        isDefined,
        isUndefined,
        DeepPartial,
        isNullOrUndefined,
    } from '@/shared/helpers/types'
    import { useUserStore } from '@/shared/user/stores/UserStore'

    import { z } from 'zod'
    import { useRechercheGmaoConfigurationInterventionEquipement } from '@/interventionServiceOffer/composables/equipement/useRechercheGmaoConfigurationInterventionEquipement'
    import { Equipement } from '@/interventionServiceOffer/entities/equipement/Equipement'
    import { EquipementFilters } from '@/interventionServiceOffer/entities/equipement/filters/EquipementFilters'
    import { RequestAborter } from '@/shared/api/entities/RequestAborter'
    import { onBeforeUnmount } from 'vue'
    import STextareaWithUndefinedValueIfEmptyField from '@/shared/formField/components/STextareaWithUndefinedValueIfEmptyField.vue'
    import { SilabError } from '@/shared/errors/SilabError'

    const msal = useMsal()
    const userStore = useUserStore(msal)

    interface Props {
        modelValue: DeepPartial<InterventionServiceOffer>
        loading: boolean
    }

    const props = defineProps<Props>()

    const emit = defineEmits<{
        'update:modelValue': [value: DeepPartial<InterventionServiceOffer>]
    }>()

    const interventionServiceOffer: WritableComputedRef<
        DeepPartial<InterventionServiceOffer>
    > = computed({
        get() {
            return props.modelValue
        },
        set(interventionServiceOffer) {
            emit('update:modelValue', interventionServiceOffer)
        },
    })

    const gmaoConfigurationInterventionId: ComputedRef<
        GmaoConfigurationIntervention['id'] | undefined
    > = computed(() => {
        return interventionServiceOffer.value.gmaoConfiguration?.id
    })

    const rechercheEquipement =
        useRechercheGmaoConfigurationInterventionEquipement(
            msal,
            gmaoConfigurationInterventionId
        )

    const formIsValid = ref<boolean>(false)

    const descriptionMaxSize = 500

    const rules = {
        hasUrlImage: (input: string | undefined) =>
            !!input || "Vous devez renseigner une Url d'illustration",
        hasTitle: (input: string | undefined) =>
            !!input || 'Vous devez renseigner un titre',
        hasShortEnoughDescription: (input: string) =>
            isDefined(input)
                ? input.length <= descriptionMaxSize ||
                  'La description doit faire moins de ' +
                      descriptionMaxSize +
                      ' caractères'
                : true,
        hasEnvironmentName: (input: string | undefined) =>
            !!input || "Vous devez renseigner un nom d'environnement",
        hasGmaoConfiguration: (input: string | undefined) =>
            !!input || 'Vous devez renseigner une configuration GMAO',
        hasDefautTimeForActivités: (input: string | undefined | null) =>
            !!input || 'Vous devez renseigner une heure par défaut',
        hasModeDateDeDebutForActivités: (input: string | undefined | null) =>
            !!input ||
            'Vous devez choisir un mode de selection de la date/heure des activités',
    }

    const gmaoConfigurationInterventionApi =
        new GmaoConfigurationInterventionApi(msal)
    const gmaoConfigurationInterventions: VolatileRef<
        GmaoConfigurationIntervention[]
    > = ref({ complete: false, data: [] })

    watch(
        [() => msal.accounts, () => userStore.isImpersonating],
        () => {
            gmaoConfigurationInterventionApi
                .getAll()
                .then(
                    (fetchedGmaoConfigurationInterventions) =>
                        (gmaoConfigurationInterventions.value = {
                            complete: true,
                            data: fetchedGmaoConfigurationInterventions,
                        })
                )
                .catch((error) => {
                    if (error.name !== 'AbortError') {
                        throw new SilabError((<Error>error).message, 'error')
                    }
                })
        },
        { immediate: true }
    )

    const heureParDefautEnMinutesInput = computed<string | null | undefined>({
        get: () => {
            if (
                isUndefined(
                    interventionServiceOffer.value
                        .configurationFormulaireActivite?.heureParDefautEnMinute
                )
            ) {
                return undefined
            }

            const heuresStr = String(
                Math.floor(
                    interventionServiceOffer.value
                        .configurationFormulaireActivite
                        .heureParDefautEnMinute / 60
                )
            ).padStart(2, '0')
            const minutesStr = String(
                interventionServiceOffer.value.configurationFormulaireActivite
                    .heureParDefautEnMinute % 60
            ).padStart(2, '0')
            return `${heuresStr}:${minutesStr}`
        },
        set: (timeString: string | undefined | null) => {
            if (
                isUndefined(
                    interventionServiceOffer.value
                        .configurationFormulaireActivite
                )
            ) {
                return
            }
            if (isNullOrUndefined(timeString) || timeString === '') {
                interventionServiceOffer.value.configurationFormulaireActivite.heureParDefautEnMinute =
                    undefined
                return
            }
            const decomposedTimeString =
                /(?<heures>\d\d):(?<minutes>\d\d)/.exec(timeString)
            const heures = Number(
                z.string().parse(decomposedTimeString?.groups?.heures)
            )
            const minutes = Number(
                z.string().parse(decomposedTimeString?.groups?.minutes)
            )
            interventionServiceOffer.value.configurationFormulaireActivite.heureParDefautEnMinute =
                heures * 60 + minutes
        },
    })

    const availableEquipementsCache: Ref<Equipement[] | undefined> =
        ref(undefined)

    const availableEquipements: WritableComputedRef<Equipement[] | undefined> =
        computed({
            get: () => {
                return availableEquipementsCache.value
            },
            set: (equipements) => {
                availableEquipementsCache.value = equipements
                interventionServiceOffer.value.availableEquipementsIds =
                    equipements?.map((equipement) => equipement.id)
            },
        })
    const gmaoEquipementApi = new GmaoConfigurationInterventionApi(msal)
    const gmaoEquipementApiFetchAborter = new RequestAborter()

    watch(
        () => interventionServiceOffer.value.gmaoConfiguration,
        () => {
            gmaoEquipementApiFetchAborter.abortRequestsAndRefreshAborter()
            availableEquipementsCache.value = undefined
            if (
                isUndefined(
                    interventionServiceOffer.value.gmaoConfiguration?.id
                ) ||
                isUndefined(
                    interventionServiceOffer.value.availableEquipementsIds
                )
            ) {
                return
            }

            if (
                interventionServiceOffer.value.availableEquipementsIds
                    .length === 0
            ) {
                availableEquipementsCache.value = []
                return
            }
            gmaoEquipementApi
                .getAllEquipements(
                    interventionServiceOffer.value.gmaoConfiguration.id,
                    new EquipementFilters({
                        id: interventionServiceOffer.value
                            .availableEquipementsIds,
                        'currentStatus.code': ['active'],
                    }),
                    gmaoEquipementApiFetchAborter.getSignal()
                )
                .then((fetchedEquipements) => {
                    availableEquipementsCache.value = fetchedEquipements
                })
                .catch((error) => {
                    if (error.name !== 'AbortError') {
                        throw new SilabError((<Error>error).message, 'error')
                    }
                })
        },
        { immediate: true }
    )
    onBeforeUnmount(() => {
        gmaoEquipementApiFetchAborter.abortRequests()
    })
</script>

<template>
    <v-form v-model="formIsValid">
        <v-textarea
            v-model="interventionServiceOffer.notes"
            label="Notes pour les administrateurs"
            variant="outlined"
            data-cy="service-offer-notes"
            auto-grow
        />

        <v-text-field
            v-model="interventionServiceOffer.image"
            label="Url de l'illustration*"
            :rules="[rules.hasUrlImage]"
            data-cy="image"
        />

        <v-text-field
            v-model="interventionServiceOffer.title"
            label="Titre*"
            :rules="[rules.hasTitle]"
            data-cy="service-offer-title"
        />

        <v-textarea
            v-model="interventionServiceOffer.description"
            label="Description"
            :rules="[rules.hasShortEnoughDescription]"
            :counter="descriptionMaxSize"
            variant="outlined"
            data-cy="service-offer-description"
            auto-grow
        />

        <v-select
            v-model="interventionServiceOffer.environnement"
            label="Environnement*"
            variant="outlined"
            :items="['PROD', 'INTEG', 'TEST']"
            clearable
            :rules="[rules.hasEnvironmentName]"
            data-cy="environnement"
        />

        <v-select
            v-model="interventionServiceOffer.gmaoConfiguration"
            label="Configuration GMAO*"
            variant="outlined"
            :items="
                gmaoConfigurationInterventions.data as DeepPartial<GmaoConfigurationIntervention>[]
            "
            return-object
            clearable
            :rules="[rules.hasGmaoConfiguration]"
            :loading="!gmaoConfigurationInterventions.complete"
            data-cy="gmaoConfiguration"
        >
            <template #item="{ props: activatorProps, item }">
                <v-list-item
                    v-bind="activatorProps"
                    :subtitle="item.raw.environnement"
                ></v-list-item>
            </template>
        </v-select>

        <h2 class="pt-8">Equipements</h2>

        <v-autocomplete
            v-model="availableEquipements"
            v-model:search="rechercheEquipement.labelRecherché.value"
            :disabled="
                isNullOrUndefined(interventionServiceOffer.gmaoConfiguration) ||
                isUndefined(availableEquipements)
            "
            label="Ajouter un équipement"
            placeholder="Rechercher un équipement"
            variant="outlined"
            prepend-icon="mdi-cube-outline"
            data-cy="select-equipement"
            chips
            closable-chips
            hide-no-data
            :hint="
                isNullOrUndefined(interventionServiceOffer.gmaoConfiguration)
                    ? 'Vous devez choisir une configuration GMAO avant de pouvoir ajouter des équipements'
                    : undefined
            "
            persistent-hint
            multiple
            clearable
            :item-title="
                (equipement) => `${equipement.label} - ${equipement.code}`
            "
            return-object
            :loading="
                rechercheEquipement.isLoading.value ||
                gmaoEquipementApi.isProcessing.value
            "
            :items="rechercheEquipement.resultatsRecherche.value"
            class="mt-3"
        />

        <h2 class="pt-8">Demandes</h2>

        <s-textarea-with-undefined-value-if-empty-field
            v-model="
                interventionServiceOffer.modeleDeDescriptionPourDemandeIntervention
            "
            label="Définir un modèle de description pour les demandes d'intervention"
            variant="outlined"
            data-cy="modeleDescriptionTextarea"
            auto-grow
            class="mt-4"
        />

        <v-switch
            v-model="
                interventionServiceOffer.gestionDatesSouhaiteesPourDemandeInterventionActif
            "
            label="Utiliser la saisie des dates de début et de fin souhaitées dans les formulaires"
            color="primary"
            data-cy="gestion-date-souhaitee-demande-intervention"
            hide-details="auto"
        />

        <h2 class="pt-8">Interventions</h2>

        <v-switch
            v-model="interventionServiceOffer.gestionDatesPourInterventionActif"
            label="Utiliser la saisie des dates de début et de fin dans les formulaires"
            color="primary"
            data-cy="gestion-date-intervention"
            hide-details="auto"
        />

        <h3 class="pt-6">Traitement d'interventions</h3>

        <v-switch
            v-model="interventionServiceOffer.gestionRecompletementActif"
            label="Utiliser la gestion de recomplètement"
            color="primary"
            hint="Un champ permettant de renseigner les matériels consommés sera disponible sur l'ecran de traitement(soldage) d'une intervention"
            persistent-hint
            data-cy="gestion-recompletement"
        />

        <template
            v-if="
                isDefined(
                    interventionServiceOffer.configurationFormulaireActivite
                        ?.dateDeDebut
                )
            "
        >
            <h4 class="pt-6">Activités</h4>

            <v-radio-group
                v-model="
                    interventionServiceOffer.configurationFormulaireActivite
                        .dateDeDebut
                "
                data-cy="service-offer-mode-date"
                label="Saisie de la date"
                :rules="[rules.hasModeDateDeDebutForActivités]"
            >
                <v-radio
                    label="Automatique : date/heure du jour moins la durée de l'intervention"
                    value="automatique"
                    data-cy="service-offer-mode-date-automatique"
                ></v-radio>
                <v-radio
                    label="Date uniquement : date modifiable, initialisé à la date du jour avec l'heure configurée par défaut"
                    value="jour"
                    data-cy="service-offer-mode-date-jour"
                ></v-radio>
                <v-radio
                    label="Date et heure : date/heure modifiable, initialisé à la date/heure du jour"
                    value="heure"
                    data-cy="service-offer-mode-date-heure"
                ></v-radio>
            </v-radio-group>
            <v-text-field
                v-model="heureParDefautEnMinutesInput"
                label="heure par défaut"
                data-cy="service-offer-heure-par-defaut-en-minutes"
                :rules="[rules.hasDefautTimeForActivités]"
                type="time"
                persistent-hint
            />

            <s-action-button
                icon="mdi-check"
                label="Enregistrer"
                display="floating-fixed"
                position="right"
                type="submit"
                :disabled="!formIsValid"
                :loading="loading"
                data-cy="submit"
            />
        </template>
    </v-form>
</template>
